-- Author      : Txty
-- Create Date : 9/23/2014 12:27:36 AM
local _, namespace = ...
local L = namespace.L
-------------------------------------
local myTable = {}
	myTable["Grey"] = {0.50,0.50,0.50}
	myTable["Black"] = {0.00,0.00,0.00}
	myTable["Death Knight"] = {0.77,0.12,0.23}
	myTable["Demon Hunter"] = {0.64,0.19,0.79}
	myTable["Druid"] = {1.00,0.49,0.04}
	myTable["Hunter"] = {0.67,0.83,0.45}
	myTable["Mage"] = {0.25,0.78,0.92}
	myTable["Monk"] = {0.00,1.00,0.59}
	myTable["Paladin"] = {0.96,0.55,0.73}
	myTable["Priest"] = {1.00,1.00,1.00}
	myTable["Rogue"] = {1.00,0.96,0.41}
	myTable["Shaman"] = {0.00,0.44,0.87	}
	myTable["Warlock"] = {0.53,0.53,0.93}
	myTable["Warrior"] = {0.78,0.61,0.43}
-------------------------------------
local myMsg = {
	"1",
	"2",
	"3",
	"4",
	"Big",
	"All to",
	"is safe",	
}
-------------------------------------
local myChatArray = {
	"SAY",
	"YELL",
	"WHISPER",
	"PARTY",
	"RAID",
	"RAID_WARNING",
--	"battleground",
	"INSTANCE_CHAT",
	"AFK",
	"DND",
	"system",
	"CHANNEL",
}
-------------------------------------
local myGlobalChannels = {
	"1.LookingForGroup",
	"2.General",
	"3.Trade - City",
	"4.LocalDefense",
	"5.WorldDefense",
	"6.GuildRecruitment - City"
}
-------------------------------------
function namespace.classColor(class)
	local x,y,z
	if myTable[class] then
		x = myTable[class][1]
		y = myTable[class][2]
		z = myTable[class][3]
	end
	namespace.config.db.char.color = class
	BGCallouts:SetBackdropBorderColor(x, y, z, 0.7)
end
-------------------------------------
local function setTarget()
	if UnitExists("target") then
		namespace.config.db.char.playerName = GetUnitName('target', true)
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou will now whisper " .. namespace.config.db.char.playerName)
	else
		namespace.config.db.char.playerName = GetUnitName('player', true)
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou have no target and will now whisper yourself")
	end
	return namespace.config.db.char.playerName
end
-------------------------------------
function namespace.SetChatType(msg)
	if msg == "RAID_WARNING" then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou must be raid leader or assistant.")
	elseif msg == "WHISPER" then
		namespace.config.db.char.target = setTarget()
	else
		namespace.config.db.char.target = nil
	end
	namespace.config.db.char.chatType = msg

	for i=1, #myGlobalChannels do
		if msg == myGlobalChannels[i] then
			namespace.config.db.char.chatType = CHANNEL
			namespace.config.db.char.target = i
		end
	end
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccffYou are now sending to: " .. msg)
end
-------------------------------------
function namespace.myLock(frameName)
	local point, relativeTo, relativePoint, xOfs, yOfs = frameName:GetPoint()
		frameName:SetMovable(false)
		frameName:EnableMouse(false)
		frameName:SetAlpha(1)
		namespace.config.db.char.lock = true
		namespace.config.db.char.point = point
		namespace.config.db.char.relativePoint = relativePoint
		namespace.config.db.char.setPointx = xOfs
		namespace.config.db.char.setPointy = yOfs
		namespace.myButtons("show", namespace.config.db.char.bg)
	end
-----------------------------------
function namespace.myUnLock(frameName)
	frameName:SetMovable(true)
	frameName:EnableMouse(true)
	frameName:RegisterForDrag("LeftButton")
	frameName:SetAlpha(0.5)
	namespace.config.db.char.lock = false
	namespace.myButtons("set", namespace.config.db.char.bg)
end
-------------------------------------
local function SetMyScale(size)
	namespace.config.db.char.size = size
	BGCallouts:SetScale(size)
end
-------------------------------------
local function disableFrame()
	namespace.config.db.char.enabled = false
	BGCallouts:Hide()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccff" .. "Addon is disabled" .. " " .. "'/dhb show' for enable it.")
end
-------------------------------------
local function sendEmote(msg)
	SendChatMessage(msg, "EMOTE")
end
-------------------------------------
local function setLanguage(msg,language)
	namespace.config.db.char.language = language
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccff" .. msg)
end
-------------------------------------
local function getButton()
	return namespace.config.db.char.button
end
-------------------------------------
local function macroExist(name)
	if select(1,GetMacroInfo(name)) == nil then
		msg = "'!msg3' or '!msg4' do not exist."
	elseif select(3,GetMacroInfo(name)) == "" then
		msg = "'!msg3' or '!msg4' has no content."	
	else
		msg = select(3,GetMacroInfo(name))
	end
	return msg
end
-------------------------------------
local function setBattleground(bg, row, col)
	namespace.config.db.char.row = row
	namespace.config.db.char.col = col
	namespace.config.db.char.bg = bg
	BGCallouts:SetSize(namespace.config.db.char.col * 40+18, namespace.config.db.char.row * 40+18)
	namespace.myButtons('set', bg)
end
-------------------------------------
local function MessageTextBefore(icon,message,name)
--	icon=":@"
	if (namespace.config.db.char.chatType == 'system' or string.sub(message,1,18) == "'!msg1' or '!msg2'") then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff96BGCallouts: |cff00ccff" .. icon .. message .. name)
	else
		SendChatMessage(format("%s %s %s", icon, message, name), namespace.config.db.char.chatType, namespace.config.db.char.language, namespace.config.db.char.target)
	end
end
-------------------------------------
-- Menus
-------------------------------------
namespace.menu = {
	{ text = "|cfffff569Menu", notCheckable = true, isTitle = true},
	{ text = "Lock Frame", notCheckable = true, func = function() namespace.myLock(BGCallouts); end},
	{ text = "Set color", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569Select a class color", notCheckable = true, isTitle = true},
			{ text = "Grey", notCheckable = true, func = function() namespace.classColor("Grey"); end},
			{ text = "Black", notCheckable = true, func = function() namespace.classColor("Black"); end},
			{ text = "Death Knight", notCheckable = true, func = function() namespace.classColor("Death Knight"); end},
			{ text = "Demon Hunter", notCheckable = true, func = function() namespace.classColor("Demon Hunter"); end},
			{ text = "Druid", notCheckable = true, func = function() namespace.classColor("Druid"); end},
			{ text = "Hunter", notCheckable = true, func = function() namespace.classColor("Hunter"); end},
			{ text = "Mage", notCheckable = true, func = function() namespace.classColor("Mage"); end},
			{ text = "Monk", notCheckable = true, func = function() namespace.classColor("Monk"); end},
			{ text = "Paladin", notCheckable = true, func = function() namespace.classColor("Paladin"); end},
			{ text = "Priest", notCheckable = true, func = function() namespace.classColor("Priest"); end},
			{ text = "Rogue", notCheckable = true, func = function() namespace.classColor("Rogue"); end},
			{ text = "Shaman", notCheckable = true, func = function() namespace.classColor("Shaman"); end},
			{ text = "Warlock", notCheckable = true, func = function() namespace.classColor("Warlock"); end},
			{ text = "Warrior", notCheckable = true, func = function() namespace.classColor("Warrior"); end}
		},
	},
	{ text = "Set scale", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569Select a size", notCheckable = true, isTitle = true},
			{ text = "Extra small", notCheckable = true, func = function() SetMyScale(0.5); end},
			{ text = "Small", notCheckable = true, func = function() SetMyScale(0.6); end},
			{ text = "Medium", notCheckable = true, func = function() SetMyScale(0.8); end},
			{ text = "Large", notCheckable = true, func = function() SetMyScale(1.0); end},
			{ text = "Extra Large", notCheckable = true, func = function() SetMyScale(1.2); end}			
		},
	},
	{ text = "Set channel", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569Select a chat type", notCheckable = true, isTitle = true},
			{ text = myChatArray[1], notCheckable = true, func = function() namespace.SetChatType(myChatArray[1]); end},
			{ text = myChatArray[2], notCheckable = true, func = function() namespace.SetChatType(myChatArray[2]); end},
			{ text = myChatArray[3] .. " - set target", notCheckable = true, func = function() namespace.SetChatType(myChatArray[3]); end},
			{ text = myChatArray[4], notCheckable = true, func = function() namespace.SetChatType(myChatArray[4]); end},
			{ text = myChatArray[5], notCheckable = true, func = function() namespace.SetChatType(myChatArray[5]); end},
			{ text = myChatArray[6], notCheckable = true, func = function() namespace.SetChatType(myChatArray[6]); end},
			{ text = myChatArray[7], notCheckable = true, func = function() namespace.SetChatType(myChatArray[7]); end},
			{ text = myChatArray[8], notCheckable = true, func = function() namespace.SetChatType(myChatArray[8]); end},
			{ text = myChatArray[9], notCheckable = true, func = function() namespace.SetChatType(myChatArray[9]); end},
			{ text = myChatArray[10], notCheckable = true, func = function() namespace.SetChatType(myChatArray[10]); end},
	--		{ text = myChatArray[11], notCheckable = true, func = function() namespace.SetChatType(myChatArray[11]); end},
			{ text = "Global Channels", notCheckable = true, hasArrow = true, menuList = {
	--					{ text = myChatArray[10], notCheckable = true, func = function() namespace.SetChatType(myChatArray[10]); end},
					{ text = myGlobalChannels[1], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[1]); end},
					{ text = myGlobalChannels[2], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[2]); end},
					{ text = myGlobalChannels[3], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[3]); end},
					{ text = myGlobalChannels[4], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[4]); end},
					{ text = myGlobalChannels[5], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[5]); end},
					{ text = myGlobalChannels[6], notCheckable = true, func = function() namespace.SetChatType(myGlobalChannels[6]); end}
				},
			},
		},
	},
	{ text = "Set language", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569Alliance languages", notCheckable = true, isTitle = true},
			{ text = "Humans - common", notCheckable = true, func = function() setLanguage('common',1); end},
			{ text = "Night Elves - Darnassian", notCheckable = true, func = function() setLanguage('Darnassian',7); end},
			{ text = "Dwarves Dwarven", notCheckable = true, func = function() setLanguage('Dwarven',6); end},
			{ text = "Gnomes - Gnomish", notCheckable = true, func = function() setLanguage('Gnomish',13); end},
			{ text = "Draenei - Draenei", notCheckable = true, func = function() setLanguage('Draenei',35); end},
			{ text = "Worgen - common", notCheckable = true, func = function() setLanguage('common',7); end},
			{ text = "Void elves - Thalassian", notCheckable = true, func = function() setLanguage('Thalassian',182); end},
			{ text = "|cfffff569Horde languages", notCheckable = true, isTitle = true},
			{ text = "Orcs - Orcish - common", notCheckable = true, func = function() setLanguage('Orcish',1); end},
			{ text = "Trolls - Zandali", notCheckable = true, func = function() setLanguage('Zandali',14); end},
			{ text = "Tauren - Taur-ahe", notCheckable = true, func = function() setLanguage('Taur-ahe',3); end},
			{ text = "Forsaken - Gutterspeak", notCheckable = true, func = function() setLanguage('Gutterspeak',33); end},
			{ text = "Blood Elves - Thalassian", notCheckable = true, func = function() setLanguage('Thalassian',182); end},
			{ text = "Goblin - Goblin", notCheckable = true, func = function() setLanguage('Goblin',40); end},
			{ text = "Nightborne - Shalassian", notCheckable = true, func = function() setLanguage('Shalassian',181); end},
			{ text = "Vulpera - Vulpera", notCheckable = true, func = function() setLanguage('Vulpera',285); end},
			{ text = "|cfffff569Cross-faction languages", notCheckable = true, isTitle = true},
			{ text = "|cffdae3e0Thalassian - see above", notCheckable = true, disabled = true, func = function() setLanguage('Thalassian',182); end},
			{ text = "Pandaren - Pandaren", notCheckable = true, func = function() setLanguage('Pandaren',42); end},
			{ text = "|cffdae3e0Demon Hunters - Demonic - talent", notCheckable = true, func = function() setLanguage('Demonic',8); end}
		},
	},
	{ text = "Set Battleground", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569Select a Battleground", notCheckable = true, isTitle = true},
			{ text = "Arathi Basin", notCheckable = true, func = function() setBattleground("ab", 5, 1); end},
			{ text = "Alterac Valley", notCheckable = true, func = function() setBattleground("av", 7, 2); end},
			{ text = "Eye of the Storm", notCheckable = true, func = function() setBattleground("eots", 5, 1); end},
			{ text = "Strand of the Ancients", notCheckable = true, func = function() setBattleground("sota", 5, 1); end},			
			{ text = "Warsong Gulch", notCheckable = true, func = function() setBattleground("wg", 2, 1); end}
		},
	},	
	{ text = "Information", notCheckable = true, hasArrow = true, menuList = {
			{ text = "Information", notCheckable = true, hasArrow = true, menuList = {
					{ text = "Information", notCheckable = true, isTitle = true},
					{ text = "Unlocked and Left Mouse Button", colorCode = "|cfffff569", notCheckable = true},
					{ text = "Top button will be hidden and clickable for moving.", notCheckable = true},
					{ text = "Unlocked and Right Mouse Button", colorCode = "|cfffff569", notCheckable = true},
					{ text = "Buttons is for menu.", notCheckable = true},
					{ text = "Set target will reset every time you reload.", notCheckable = true},
					{ text = "Disable frame and it will not auto pop up.", notCheckable = true},
					{ text = "Locked and Left Mouse Button", colorCode = "|cfffff569", notCheckable = true},
					{ text = "This is for custom messages and emotes.", notCheckable = true},
					{ text = "!msg3 - is custom mesage or a custom emote.", notCheckable = true},
					{ text = "!msg4 - is for DoEmotes or sound emotes, you type in (ex. chicken).", notCheckable = true},
					{ text = "A handful of emotes.", notCheckable = true},
					{ text = "Locked and Right Mouse Button", colorCode = "|cfffff569", notCheckable = true},
					{ text = "This is the core of the addon.", notCheckable = true},
					{ text = "Here you set number of incoming players or if base is safe.", notCheckable = true},
					{ text = "Remember", colorCode = "|cfffff569", notCheckable = true},
					{ text = "You have to 'Lock Frame' to store position.", notCheckable = true},
					{ text = "Name custom messages !msg3 and !msg4 to not interfer with my other addon 'DungeonHelper2'", notCheckable = true},
					{ text = "For the 'DoEmotes' to work you can not have a carriage return in your macro body.", notCheckable = true},
					{ text = "Enable sound for the emotes in system settings.", notCheckable = true}
				},	
			},		
		},
	},
	{ text = "Hide Frame", notCheckable = true, func = function() BGCallouts:Hide(); end},
	{ text = "Disable Frame", notCheckable = true, func = function() disableFrame(); end}
}
-------------------------------------
namespace.menu1 = {
	{ text = myMsg[1], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[1]] .. L[" incoming at "], getButton()); end},
	{ text = myMsg[2], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[2]] .. L[" incoming at "], getButton()); end},
	{ text = myMsg[3], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[3]] .. L[" incoming at "], getButton()); end},
	{ text = myMsg[4], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[4]] .. L[" incoming at "], getButton()); end},
	{ text = myMsg[5], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[5]] .. L[" incoming at "], getButton()); end},
	{ text = myMsg[6], notCheckable = true, func = function() MessageTextBefore("", L[myMsg[6]] .. " ", getButton()); end},
	{ text = myMsg[7], notCheckable = true, func = function() MessageTextBefore("", getButton(), " " .. L[myMsg[7]]); end},
--	{ text = myMsg[5], notCheckable = true, func = function() MessageTextBefore("{rt7}", L[myMsg[5]], getButton()); end},
--	{ text = myMsg[6], notCheckable = true, func = function() MessageTextBefore("{rt8}", L[myMsg[6]], getButton()); end},
--	{ text = myMsg[7], notCheckable = true, func = function() MessageTextBefore("{rt4}", getButton(), L[myMsg[7]]); end},
}
-------------------------------------
namespace.menu2 = {
	{ text = "Custom !msg3", notCheckable = true, func = function() MessageTextBefore('', macroExist('!msg3'), ''); end},
	{ text = "Custom !msg4", notCheckable = true, func = function() MessageTextBefore('', macroExist('!msg4'), ''); end},
	{ text = "|cfffff569---------------", notCheckable = true, isTitle = true},
	{ text = "Custom Emote !msg3", notCheckable = true, func = function() sendEmote(macroExist('!msg3')); end},
	{ text = "DoEmote !msg4", notCheckable = true, func = function() DoEmote(macroExist('!msg4')); end},
	{ text = "|cfffff569---------------", notCheckable = true, isTitle = true},
	{ text = "Emotes A-K", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569AB ---------", notCheckable = true, isTitle = true},
			{ text = "blush", notCheckable = true, func = function() DoEmote("blush"); end},
			{ text = "bonk", notCheckable = true, func = function() DoEmote("bonk"); end},
			{ text = "bow", notCheckable = true, func = function() DoEmote("bow"); end},
			{ text = "bye", notCheckable = true, func = function() DoEmote("bye"); end},
			{ text = "|cfffff569C ----------", notCheckable = true, isTitle = true},
			{ text = "cheer", notCheckable = true, func = function() DoEmote("cheer"); end},
			{ text = "chicken", notCheckable = true, func = function() DoEmote("chicken"); end},
			{ text = "clap", notCheckable = true, func = function() DoEmote("clap"); end},
			{ text = "commend", notCheckable = true, func = function() DoEmote("commend"); end},
			{ text = "confused", notCheckable = true, func = function() DoEmote("confused"); end},
			{ text = "curious", notCheckable = true, func = function() DoEmote("curious"); end},
			{ text = "|cfffff569DEF --------", notCheckable = true, isTitle = true},
			{ text = "dance", notCheckable = true, func = function() DoEmote("dance"); end},
			{ text = "drink", notCheckable = true, func = function() DoEmote("drink"); end},
			{ text = "flee", notCheckable = true, func = function() DoEmote("flee"); end},
			{ text = "flex", notCheckable = true, func = function() DoEmote("flex"); end},
			{ text = "flirt", notCheckable = true, func = function() DoEmote("flirt"); end},
			{ text = "|cfffff569GH ---------", notCheckable = true, isTitle = true},
			{ text = "gasp", notCheckable = true, func = function() DoEmote("gasp"); end},
			{ text = "giggle", notCheckable = true, func = function() DoEmote("giggle"); end},
			{ text = "growl", notCheckable = true, func = function() DoEmote("growl"); end},
			{ text = "healme", notCheckable = true, func = function() DoEmote("healme"); end},
			{ text = "hello", notCheckable = true, func = function() DoEmote("hello"); end},
			{ text = "helpme", notCheckable = true, func = function() DoEmote("helpme"); end},
			{ text = "|cfffff569IJK --------", notCheckable = true, isTitle = true},
			{ text = "incoming", notCheckable = true, func = function() DoEmote("incoming"); end},
			{ text = "insult", notCheckable = true, func = function() DoEmote("insult"); end},
			{ text = "kiss", notCheckable = true, func = function() DoEmote("kiss"); end},
			{ text = "kneel", notCheckable = true, func = function() DoEmote("kneel"); end}
		},
	},
	{ text = "Emotes L-Z", notCheckable = true, hasArrow = true, menuList = {
			{ text = "|cfffff569LMN --------", notCheckable = true, isTitle = true},
			{ text = "lost", notCheckable = true, func = function() DoEmote("lost"); end},
			{ text = "mourn", notCheckable = true, func = function() DoEmote("mourn"); end},
			{ text = "no", notCheckable = true, func = function() DoEmote("no"); end},
			{ text = "|cfffff569OPQ --------", notCheckable = true, isTitle = true},
			{ text = "oom", notCheckable = true, func = function() DoEmote("oom"); end},
			{ text = "point", notCheckable = true, func = function() DoEmote("point"); end},
			{ text = "|cfffff569R ----------", notCheckable = true, isTitle = true},
			{ text = "roar", notCheckable = true, func = function() DoEmote("roar"); end},
			{ text = "rofl", notCheckable = true, func = function() DoEmote("rofl"); end},
			{ text = "|cfffff569S ----------", notCheckable = true, isTitle = true},
			{ text = "salute", notCheckable = true, func = function() DoEmote("salute"); end},
			{ text = "sigh", notCheckable = true, func = function() DoEmote("sigh"); end},
			{ text = "silly", notCheckable = true, func = function() DoEmote("silly"); end},
			{ text = "sleep", notCheckable = true, func = function() DoEmote("sleep"); end},
			{ text = "surrender", notCheckable = true, func = function() DoEmote("surrender"); end},
			{ text = "|cfffff569T ----------", notCheckable = true, isTitle = true},
			{ text = "talk", notCheckable = true, func = function() DoEmote("talk"); end},
			{ text = "thank", notCheckable = true, func = function() DoEmote("thank"); end},
			{ text = "train", notCheckable = true, func = function() DoEmote("train"); end},
			{ text = "|cfffff569UVW --------", notCheckable = true, isTitle = true},
			{ text = "violin", notCheckable = true, func = function() DoEmote("violin"); end},
			{ text = "wait", notCheckable = true, func = function() DoEmote("wait"); end},
			{ text = "wave", notCheckable = true, func = function() DoEmote("wave"); end},
			{ text = "welcome", notCheckable = true, func = function() DoEmote("welcome"); end},
			{ text = "whistle", notCheckable = true, func = function() DoEmote("whistle"); end},
			{ text = "|cfffff569XYZ --------", notCheckable = true, isTitle = true},
			{ text = "yawn", notCheckable = true, func = function() DoEmote("yawn"); end}		
		},
	},
	{ text = "|cfffff569---------------", notCheckable = true, isTitle = true},
	{ text = "Unlock Frame", notCheckable = true, func = function() namespace.myUnLock(BGCallouts); end}
}
--END--------------------------------
